#include "commonheaders.h"
#include "cls-window.h"
#include "cls-windraw.h"

ListBox::ListBox(short xLocation, short yLocation, short winWidth, short elements, short *refval) {
    xPos = xLocation;
    yPos = yLocation;
    width = winWidth;
    display = elements;
    display = (display < 3 ? 3 : display);
    ref = refval;
    
    list = NULL;
    items = 0;
    index = 0;

    up = false;
    down = false;
    slider = false;
    highlight = create_bitmap(width - 2, 10);
    draw_hbar_gradient(highlight, 0, 0, width - 2, 10, makecol(192, 192, 192), makecol(128, 128, 128));
}
bool ListBox::CheckItem(char *newitem) {
    if(list != NULL) {
        short i = 0;
        while(i < items - 1 && list[i] != NULL) {
            if(strcmp(newitem, list[i]) == 0) {
                break;
            }
            i++;
        }
        if(strcmp(newitem, list[i]) == 0) {
            return true;
        }
    }
    return false;
}
bool ListBox::ReplaceItem(char *olditem, char *newitem) {
    if(list != NULL) {
        short i = 0, itemgood = -1, itembad = -1;
        while(i < items - 1 && list[i] != NULL) {
            if(strcmp(newitem, list[i]) == 0) {
                itemgood = i;
            }
            if(strcmp(olditem, list[i]) == 0) {
                itembad = i;
            }
            i++;
        }
        if(itembad == -1 && itemgood != -1) {
            list[itemgood] = (char *)qualloc(list[itemgood], sizeof(char) * strlen(newitem) + 1);
            Init_String(list[itemgood], newitem, 0);
            return true;
        }
    }
    return false;
}
bool ListBox::AddItem(char *newitem) {
    if(list == NULL) {
        list = (char **)qualloc(sizeof(char *) * (items + 1));
        list[items] = (char *)qualloc(strlen(newitem) + 1);
    	Init_String(list[items], newitem, 0);
        *ref = items;
        *ref = (*ref < 0 ? 0 : *ref);
        index = *ref - display + 1;
        if(index > items) index = items - display;
        if(index < 0) index = 0;
        items ++;
        list[items] = NULL;
        return true;
    } else {
        short i = 0;
        while(i < items - 1 && list[i] != NULL) {
            if(strcmp(newitem, list[i]) == 0) {
                break;
            }
            i++;
        }
        if(strcmp(newitem, list[i])) {
        	list = (char **)qualloc(list, sizeof(char *) * (items + 1));
        	list[items] = NULL;
            list[items] = (char *)qualloc(sizeof(char) * strlen(newitem) + 1);
            Init_String(list[items], newitem, 0);
            *ref = items;
            *ref = (*ref < 0 ? 0 : *ref);
            index = *ref - display + 1;
            if(index > items) index = items - display;
            if(index < 0) index = 0;
            items ++;
            list[items] = NULL;
            scrollbarysize = (int)(((float)display / (float)items) * display * 10 - 18);
            scrollbaryinc = ((float)(display * 10 - 18 - scrollbarysize) / (float)(items - display + 1));
            scrollbarygrab = false;
            scrollbary = (int)scrollbaryinc * *ref;
            if(scrollbary < 0) scrollbary = 0;
            if(scrollbary > display * 10 - 18 - scrollbarysize) scrollbary = display * 10 - 18 - scrollbarysize;
            return true;
        }
    }
    return false;
}
bool ListBox::EraseItem(short itemnum) {
    for(int i = itemnum; i < items - 1; i ++)
    {
        //Copy list[i+1] into list[i].
    	list[i] = (char *)qualloc(list[i], sizeof(char) * strlen(list[i + 1]) + 1);
    	strcpy(list[i], list[i + 1]);
    }
    if(items > 0)
    {
        *ref = (*ref > 0 ? *ref - 1 : 0);
        //Erase the last component in list
        items --;
        free(list[items]);
        list[items] = NULL;
        if(items > 0) 
            list = (char **)qualloc(list, sizeof(char *) * (items));
        else
        {
            free(list);
            list = NULL;
        }
    }
    scrollbarysize = (int)(((float)display / (float)items) * (display - 1) * 10);
    scrollbaryinc = ((float)((display - 1) * 10 - scrollbarysize) / (float)(items - display));
    scrollbarygrab = false;
    scrollbary = (int)scrollbaryinc * *ref;
    if(scrollbary < 0) scrollbary = 0;
    if(scrollbary > (display - 1) * 10 - scrollbarysize) scrollbary = (display - 1) * 10 - scrollbarysize;
    return true;
}
bool ListBox::ItemUp(short itemnum) {
    if(itemnum > 0 && itemnum < items) {
        char * tempstr;
        short len1, len2;
        len1 = strlen(list[itemnum]);
        len2 = strlen(list[itemnum - 1]);
        if(len1 > len2) {
            tempstr = (char *)qualloc(sizeof(char) * len1);
            list[itemnum - 1] = (char *)qualloc(list[itemnum - 1], sizeof(char) * len1);
            list[itemnum - 1][len2] = '\0';
            strcpy(tempstr, list[itemnum - 1]);
            strcpy(list[itemnum - 1], list[itemnum]);
            strcpy(list[itemnum], tempstr);
            list[itemnum] = (char *)qualloc(list[itemnum], sizeof(char) * len2);
            list[itemnum][len2] = '\0';
        } else if (len1 < len2) {
            tempstr = (char *)qualloc(sizeof(char) * len2);
            list[itemnum] = (char *)qualloc(list[itemnum], sizeof(char) * len2);
            list[itemnum][len1] = '\0';
            strcpy(tempstr, list[itemnum - 1]);
            strcpy(list[itemnum - 1], list[itemnum]);
            strcpy(list[itemnum], tempstr);
            list[itemnum - 1] = (char *)qualloc(list[itemnum - 1], sizeof(char) * len1);
            list[itemnum - 1][len1] = '\0';
        } else {
            tempstr = (char *)qualloc(sizeof(char) * len1);
            strcpy(tempstr, list[itemnum - 1]);
            strcpy(list[itemnum - 1], list[itemnum]);
            strcpy(list[itemnum], tempstr);
        }
        *ref = *ref - 1;
        return true;
    }
    return false;
}
bool ListBox::ItemDn(short itemnum) {
    if(itemnum >= 0 && itemnum < items - 1) {
        char * tempstr = NULL;
        short len1, len2;
        len1 = strlen(list[itemnum]);
        len2 = strlen(list[itemnum + 1]);
        if(len1 > len2) {
            tempstr = (char *)qualloc(sizeof(char) * len1);
            list[itemnum + 1] = (char *)qualloc(list[itemnum + 1], sizeof(char) * len1);
            list[itemnum + 1][len2] = '\0';
            strcpy(tempstr, list[itemnum + 1]);
            strcpy(list[itemnum + 1], list[itemnum]);
            strcpy(list[itemnum], tempstr);
            list[itemnum] = (char *)qualloc(list[itemnum], sizeof(char) * len2);
            list[itemnum][len2] = '\0';
        } else if (len1 < len2) {
            tempstr = (char *)qualloc(sizeof(char) * len2);
            list[itemnum] = (char *)qualloc(list[itemnum], sizeof(char) * len2);
            list[itemnum][len1] = '\0';
            strcpy(tempstr, list[itemnum + 1]);
            strcpy(list[itemnum + 1], list[itemnum]);
            strcpy(list[itemnum], tempstr);
            list[itemnum + 1] = (char *)qualloc(list[itemnum + 1], sizeof(char) * len1);
            list[itemnum + 1][len1] = '\0';
        } else {
            tempstr = (char *)qualloc(sizeof(char) * len1);
            strcpy(tempstr, list[itemnum + 1]);
            strcpy(list[itemnum + 1], list[itemnum]);
            strcpy(list[itemnum], tempstr);
        }
        *ref = *ref + 1;
        return true;
    }
    return false;
}
bool ListBox::Check(short xLocation, short yLocation) {
    short y = yPos + yLocation;
    if(mouse_inarea(xPos + xLocation + width - 10, yPos + yLocation, 10, 10) && !scrollbarygrab) {
        if(mouse_b & 1 && !up) {
            up = true;
            down = false;
            if(index > 0) {
                index --;
                scrollbary -= (int)scrollbaryinc;
                if((int)scrollbary < 0 || index == 0) scrollbary = 0;
            }
            //if(*ref > index + display - 1 || (index == 0 && *ref > 0)) *ref -= 1;
        }
    } else if (mouse_inarea(xPos + xLocation + width - 10, yPos + yLocation + display * 10 - 6, 10, 10) && !scrollbarygrab) {
        if(mouse_b & 1 && !down) {
            down = true;
            up = false;
            if(index < items - display) {
                index ++;
                scrollbary += (int)scrollbaryinc;
                if((int)scrollbary > display * 10 - 18 - scrollbarysize || index == items - display) scrollbary = display * 10 - 18 - scrollbarysize;
            }
            //if(*ref < index || (*ref < items - 1 && index == items - display)) *ref += 1;
        }
    } else if(items > display && mouse_inarea(xPos + xLocation + width - 10, yPos + yLocation + 10, 8, display * 10 - 10)) {
        if(mouse_b & 1 && !scrollbarygrab) {
            scrollbarygrab = true;
            scrollbarygpos = (mouse_y - y) - (int)scrollbary;
        }
        up = false;
        down = false;
    } else {
        up = false;
        down = false;
        if(list != NULL) {
            short i = 0;
            while(i < display && list[i + index] != NULL) {
                if(mouse_b & 1 && mouse_inarea(xPos + xLocation + 1, yPos + yLocation + 3 + i * 10, width - 10, 10)) {
                    *ref = i + index;
                }
                i++;
            }
        }
    }
    if(items > display) {
        if (scrollbarygrab && (mouse_y - y) != scrollbarygpos + scrollbary) {
            scrollbary = (mouse_y - y) - scrollbarygpos;
            if(scrollbary < 0) scrollbary = 0;
            if(scrollbary > display * 10 - 18 - scrollbarysize) scrollbary = display * 10 - 18 - scrollbarysize;
            index = (int)(scrollbary / scrollbaryinc);
            if(index > items - display) index = items - display;
        }
    }
    if(!(mouse_b & 1)) {
        up = false;
        down = false;
        scrollbarygrab = false;
    }
    return false;
}
void ListBox::Draw(BITMAP *output, short xLocation, short yLocation) {
    text_box(output, xPos + xLocation, yPos + yLocation, width, 4 + display * 10, makecol(64,64,64), NULL);
    if(list != NULL) {
        short i = 0;
    	while(i < display && list[i + index] != NULL && i + index < items) {
    	    if(i + index == *ref) {
                set_trans_blender(0,0,0,128);
                draw_trans_sprite(output, highlight, xPos + xLocation + 1, yPos + yLocation + 2 + (i) * 10);
        	    /*textprintf(output, font, xPos + xLocation + 5, yPos + yLocation + 5 + (i) * 10, makecol(32, 32, 32), "%s", list[i + index]);
            	textprintf(output, font, xPos + xLocation + 4, yPos + yLocation + 4 + (i) * 10, makecol(32, 32, 32), "%s", list[i + index]);
                textprintf(output, font, xPos + xLocation + 3, yPos + yLocation + 3 + (i) * 10, makecol(192, 192, 192), "%s", list[i + index]);*/
                textprintf(output, font, xPos + xLocation + 3, yPos + yLocation + 3 + (i) * 10, makecol(32, 32, 32), "%s", list[i + index]); 
            } else {
                textprintf(output, font, xPos + xLocation + 5, yPos + yLocation + 5 + (i) * 10, makecol(32, 32, 32), "%s", list[i + index]);
                textprintf(output, font, xPos + xLocation + 4, yPos + yLocation + 4 + (i) * 10, makecol(32, 32, 32), "%s", list[i + index]);
                textprintf(output, font, xPos + xLocation + 3, yPos + yLocation + 3 + (i) * 10, makecol(255, 255, 255), "%s", list[i + index]); 
            }
            i++;
        }
    }
    draw_vbar_gradient(output, xPos + xLocation + width - 10, yPos + yLocation + 10, 10, (display - 1) * 10, makecol(0,0,0), makecol(48,48,48));
    //draw_vbar_gradient(ViewBuf, xElements * gridSize + 2, 12, 12, yElements * gridSize - 23, makecol(0,0,0), makecol(48,48,48));
    if(items > display) {
        if(!scrollbarygrab) {
            draw_vbar_gradient(output, xPos + xLocation + width - 9, yPos + yLocation + 11 + (int)scrollbary, 8, scrollbarysize, makecol(116,116,116), makecol(76,76,76));
        } else {
            draw_vbar_gradient(output, xPos + xLocation + width - 9, yPos + yLocation + 11 + (int)scrollbary, 8, scrollbarysize, makecol(76,76,76), makecol(116,116,116));
        }
        hline(output, xPos + xLocation + width - 10, yPos + yLocation + 10 + (int)scrollbary, xPos + xLocation + width - 1, makecol(192,192,192));
        vline(output, xPos + xLocation + width - 10, yPos + yLocation + 10 + (int)scrollbary, yPos + yLocation + 11 + (int)scrollbary + scrollbarysize, makecol(192,192,192));
        hline(output, xPos + xLocation + width - 9, yPos + yLocation + 11 + (int)scrollbary + scrollbarysize, xPos + xLocation + width - 1, makecol(48,48,48));
        vline(output, xPos + xLocation + width - 1, yPos + yLocation + 10 + (int)scrollbary, yPos + yLocation + 11 + (int)scrollbary + scrollbarysize, makecol(48,48,48));
    }
    
    if(!down) {
        draw_sprite(output, ListDn, xPos + xLocation + width - 10, yPos + yLocation + display * 10 - 6);
    } else {
        draw_sprite(output, ListDnPush, xPos + xLocation + width - 10, yPos + yLocation + display * 10 - 6);
    }
    if(!up) {
        draw_sprite(output, ListUp, xPos + xLocation + width - 10, yPos + yLocation);
    } else {
        draw_sprite(output, ListUpPush, xPos + xLocation + width - 10, yPos + yLocation);
    }
    //textprintf(output, font, xPos + xLocation + 10, yPos + yLocation + display * 10 + 10, makecol(255, 0, 0), "%f", scrollbaryinc);
    //textprintf(output, font, xPos + xLocation + 10, yPos + yLocation + display * 10 + 20, makecol(0, 255, 0), "%i", scrollbarysize);
    //textprintf(output, font, xPos + xLocation + 10, yPos + yLocation + display * 10 + 30, makecol(0, 255, 255), "%f", scrollbary);
}
