
#include "commonheaders.h"
#include "cls-menu.h"
#include "cls-window.h"
#include "initialization.h"
#include "menufunctions.h"
#include "winfunctions.h"
#include "processing.h"
#include "window.h"

short senna;
short boo;
short rot;
bool zarg;
char *texty;
char ** DogList;
short dogs = 0;

void Initialize_Windows(void) {
    if(debug) logputs("\n\tInitializing Window System:\n\n");
    MapXSize = 36;
    MapYSize = 28;
    MapGrid = NULL;
    MapGrid = (unsigned short **)malloc(sizeof(short *) * (MapYSize));
    for(short i = 0; i < MapYSize; i++) {
        MapGrid[i] = NULL;
        MapGrid[i] = (unsigned short *)malloc(sizeof(short) * (MapXSize));
        for(short j = 0; j < MapXSize; j++) {
            MapGrid[i][j] = 0;
        }
    }
    MapSpec = NULL;
    MapSpec = (unsigned short **)malloc(sizeof(short *) * (MapYSize));
    for(short i = 0; i < MapYSize; i++) {
        MapSpec[i] = NULL;
        MapSpec[i] = (unsigned short *)malloc(sizeof(short) * (MapXSize));
        for(short j = 0; j < MapXSize; j++) {
            MapSpec[i][j] = 0;
        }
    }
    selectedroom = 0;
    roomamount = 0;

    clear_keybuf();

    NewWindow(main_width / 2 - 292, main_height / 2 - 200, 584, 362, "Map Editor", CloseMapEdit);
    //Windows[WinMapEdit]->AddSelector(4, 4, 300, 300, "Viewport", &boo, 1);
    Windows[RWin("Map Editor")]->AddViewport(6, 5, 24, 20, 16);
    Windows[RWin("Map Editor")]->Viewports[0]->ResizeIn(MapXSize, MapYSize);
    Windows[RWin("Map Editor")]->Viewports[0]->PriProc(MapPlace);
    Windows[RWin("Map Editor")]->Viewports[0]->SecProc(MapErase);
    Windows[RWin("Map Editor")]->Viewports[0]->HovProc(MapHover, false);
    Windows[RWin("Map Editor")]->Viewports[0]->DrawProc(MapDraw);
    Windows[RWin("Map Editor")]->Viewports[0]->OutProc(MapViewport);
    Windows[RWin("Map Editor")]->Viewports[0]->Grid(0);
    Windows[RWin("Map Editor")]->AddButton(314 + 96, 4, 80, 21, "New Room", OpenRoomDialog);
    Windows[RWin("Map Editor")]->AddButton(398 + 96, 4, 24, 21, Delete, DeleteRoom);
    Windows[RWin("Map Editor")]->AddButton(426 + 96, 4, 24, 21, "UP", UpRoom);
    Windows[RWin("Map Editor")]->AddButton(454 + 96, 4, 24, 21, "DN", DnRoom);
    Windows[RWin("Map Editor")]->AddListBox(314 + 96, 28, 164, 18, &selectedroom, 0);
    Windows[RWin("Map Editor")]->AddSelector(314 + 96, 216, 20, 20, MapBox, &roomtype, 0);
    Windows[RWin("Map Editor")]->AddSelector(338 + 96, 216, 20, 20, MapItem, &roomtype, 1);
    Windows[RWin("Map Editor")]->AddSelector(362 + 96, 216, 20, 20, MapSlice1, &roomtype, 2);
    Windows[RWin("Map Editor")]->AddSelector(386 + 96, 216, 20, 20, MapSlice2, &roomtype, 3);
    Windows[RWin("Map Editor")]->AddSelector(410 + 96, 216, 20, 20, MapSlice3, &roomtype, 4);
    Windows[RWin("Map Editor")]->AddSelector(434 + 96, 216, 20, 20, MapSlice4, &roomtype, 5);
    Windows[RWin("Map Editor")]->AddSelector(458 + 96, 216, 20, 20, MapElevator, &roomtype, 6);
    Windows[RWin("Map Editor")]->AddSelector(314 + 96, 240, 40, 30, MapBStretch, &roomtype, 7);
    Windows[RWin("Map Editor")]->AddSelector(358 + 96, 240, 40, 30, MapDStretch, &roomtype, 9);
    Windows[RWin("Map Editor")]->AddSelector(402 + 96, 240, 75, 30, "Label", &roomtype, 8);
    Windows[RWin("Map Editor")]->AddLabel(314 + 96, 274, "Properties:");
    Windows[RWin("Map Editor")]->AddButton(314 + 96, 284, 80, 21, "Edit Room", EditRoom);
    Windows[RWin("Map Editor")]->AddButton(398 + 96, 284, 80, 21, "Room Info", OpenRoomProperties);
    Windows[RWin("Map Editor")]->AddLabel(314 + 96, 310, "Clear Room Map:");
    Windows[RWin("Map Editor")]->AddButton(314 + 96, 320, 80, 21, "Room", ClearRoom);
    Windows[RWin("Map Editor")]->AddButton(398 + 96, 320, 80, 21, "All", ClearAll);
    Windows[RWin("Map Editor")]->Selectors[8]->Disable();
    Windows[RWin("Map Editor")]->Selectors[9]->Disable();

    NewWindow(56, 256, 528, 192, "Tiles", CloseTiles);
    for(short y = 0; y < 4; y ++) {
        for(short x = 0; x < 16; x ++) {
            Windows[RWin("Tiles")]->AddSelector(8 + x * 32, 7 + y * 32, 24, 24, TileImages[y * 16 + x], &selectedtile, y *16 + x + 1);
            Windows[RWin("Tiles")]->Selectors[y * 16 + x]->SetFunction(RefreshTilePreview);
        }
    }
    Windows[RWin("Tiles")]->AddLabel(12, 136, "Tile:");
    Windows[RWin("Tiles")]->AddScrollBox(56, 132, 56, false, &selectedtile, 1, tileamount, 1);
    Windows[RWin("Tiles")]->AddLabel(12, 156, "Row:");
    Windows[RWin("Tiles")]->AddScrollBox(56, 152, 56, false, &tilerow, 1, tileamount / 16, 1);
    Windows[RWin("Tiles")]->AddListScrollBox(136, 132, 66, false, &selectedflip, 4, "No Flip", "H Flip", "V Flip", "HV Flip");
    Windows[RWin("Tiles")]->AddScrollBox(136, 152, 66, false, &selectedrot, 0, 270, 90);
    Windows[RWin("Tiles")]->AddSelector(226, 132, 33, 33, "", &rot, -1);
    Windows[RWin("Tiles")]->AddCheckBox(266, 133, "Background", &foreground);
    Windows[RWin("Tiles")]->AddCheckBox(266, 151, "Transitional", &transitional);
    Windows[RWin("Tiles")]->Selectors[64]->NoSelect();
    /*Windows[RWin("Tiles")]->AddLabel(8, 36, "Tile:");
    Windows[RWin("Tiles")]->AddScrollBox(52, 32, 40, false, &selectedtile, 1, tileamount, 1);
    Windows[RWin("Tiles")]->AddLabel(116, 36, "Row:");
    Windows[RWin("Tiles")]->AddScrollBox(152, 32, 40, false, &tilerow, 1, tileamount / 16, 1);*/
    Windows[RWin("Tiles")]->ScrollBoxes[0]->SetFunction(ProcessTiles);
    Windows[RWin("Tiles")]->ScrollBoxes[1]->SetFunction(ProcessRows);
    Windows[RWin("Tiles")]->ScrollBoxes[2]->SetFunction(RefreshTilePreview);
    Windows[RWin("Tiles")]->ScrollBoxes[3]->SetFunction(RefreshTilePreview);
    
    NewWindow(376, 284, 248, 80, "Breakables", CloseBreakables);
	Windows[RWin("Breakables")]->AddListScrollBox(2, 4, 118, false, &breaktype, 9, "Standard Tile", "Crumble", "Shootable", "Missile", "Super Missile", "Bombable", "Power Bomb", "Screw Attack", "Speed Booster");
    Windows[RWin("Breakables")]->AddLabel(12, 30, "Timer");
	Windows[RWin("Breakables")]->AddLabel(12, 32, "_____");
    Windows[RWin("Breakables")]->AddSlider(2, 46, 240, &breaktimer, 0, 255, 1, false);
    Windows[RWin("Breakables")]->AddScrollBox(80, 28, 40, false, &breaktimer, 0, 255, 1);
	Windows[RWin("Breakables")]->AddLabel(144, 2, "Chains");
	Windows[RWin("Breakables")]->AddLabel(144, 4, "______");
    Windows[RWin("Breakables")]->AddCheckBox(144, 16, "Up", &breakup);
    Windows[RWin("Breakables")]->AddCheckBox(144, 32, "Dn", &breakdn);
    Windows[RWin("Breakables")]->AddCheckBox(192, 16, "Rt", &breakrt);
    Windows[RWin("Breakables")]->AddCheckBox(192, 32, "Lf", &breaklf);
    
    NewWindow(376, 28, 205, 260, "Doors", CloseDoors);
    Windows[RWin("Doors")]->AddLabel(12, 8, "Editing:");
    Windows[RWin("Doors")]->AddScrollBox(135, 4, 40, false, &selecteddoor, 1, 1, 1);
    Windows[RWin("Doors")]->AddLabel(12, 28, "Type:");
    Windows[RWin("Doors")]->AddListScrollBox(55, 24, 120, false, &selecteddooredit, 5, "Standard", "Automatic", "Missile", "Super Missile", "Power Bomb");
    Windows[RWin("Doors")]->AddSelector(6, 48, 40, 40, DoorRt, &selecteddoortype, 0);
    Windows[RWin("Doors")]->AddSelector(54, 48, 40, 40, DoorLf, &selecteddoortype, 1);
    Windows[RWin("Doors")]->AddSelector(102, 48, 40, 40, DoorUp, &selecteddoortype, 2);
    Windows[RWin("Doors")]->AddSelector(150, 48, 40, 40, DoorDn, &selecteddoortype, 3);
    Windows[RWin("Doors")]->AddSelector(6, 96, 51, 23, IElevator, &selecteddoortype, 4);
    Windows[RWin("Doors")]->AddLabel(100, 104, "Dir:");
    Windows[RWin("Doors")]->AddListScrollBox(135, 100, 40, false, &elevatordir, 2, "Up", "Down");
    Windows[RWin("Doors")]->AddLabel(20, 132, "Exit Room:");
    Windows[RWin("Doors")]->AddTextBox(20, 144, 160, false, DoorRoomDrop);//&roomdrop);
    Windows[RWin("Doors")]->AddButton(12, 164, 176, 15, "Check Exit Room Doors", CheckExitDoors);
    Windows[RWin("Doors")]->AddLabel(20, 184, "Exit Door:");
    Windows[RWin("Doors")]->AddScrollBox(124, 184, 40, false, &selectedexit, 1, 9999, 1);
    Windows[RWin("Doors")]->ScrollBoxes[0]->SetFunction(SetEditDoor);
    Windows[RWin("Doors")]->ScrollBoxes[1]->SetFunction(SetDoorType);
    Windows[RWin("Doors")]->ScrollBoxes[3]->SetFunction(ChangeExitDoors);
    Windows[RWin("Doors")]->AddLabel(20, 204, "Exit Door goes to:");
    Windows[RWin("Doors")]->AddLabel(20, 216, "No Doors Exist");
    Windows[RWin("Doors")]->AddLabel(20, 226, "Door #");
    Windows[RWin("Doors")]->AddLabel(68, 226, "");
    //Windows[RWin("New Room")]->AddTextBox(8, 20, 160, false, AppendRoom);
    
    NewWindow(376, 48, 240, 124, "Items", CloseItems);
    for(short y = 0; y < 3; y ++) {
        for(short x = 0; x < 7; x ++) {
            Windows[RWin("Items")]->AddSelector(8 + x * 32, 7 + y * 32, 24, 24, ItemImages[y* 7 + x], &selecteditem, y * 7 + x + 1);
        }
    }
    
    NewWindow(376, 8, 208, 244, "Clips", NULLF);
    for(short y = 0; y < 6; y ++) {
        for(short x = 0; x < 6; x ++) {
            Windows[RWin("Clips")]->AddSelector(8 + x * 32, 7 + y * 32, 24, 24, ClipImages[y* 6 + x], &selectedclip, y * 6 + x + 1);
        }
    }
    Windows[RWin("Clips")]->AddScrollBox(10, 196, 46, false, &selectedclip, 1, clipamount, 1);
    Windows[RWin("Clips")]->AddLabel(80, 200, "Page:");
    Windows[RWin("Clips")]->AddScrollBox(120, 196, 46, false, &clippage, 1, (clipamount / 36) + (clipamount % 36 > 0 ? 1 : 0), 1);
    Windows[RWin("Clips")]->ScrollBoxes[0]->SetFunction(ProcessClips);
    Windows[RWin("Clips")]->ScrollBoxes[1]->SetFunction(ProcessClipRows);
    ProcessClipRows();
    
	/*short x;
	short y;
	tile tileval;
	unsigned dir:4;
	unsigned type:12;
	char timer;
    */
    
    //NewWindow(8, 8, 350, 320, "Room Properties", CloseRoomProp);
    
	//printf("hello");readkey();
    NewWindow(8, 8, 350, 384, "Room Editor", CloseRoomEdit);
    Windows[RWin("Room Editor")]->AddLabel(6, 9, "Editing Room:");
    Windows[RWin("Room Editor")]->AddLabel(6, 308, "Tool:");
    //Windows[RWin("Room Editor")]->AddLabel(6, 308, "Tools:");
    Windows[RWin("Room Editor")]->AddButton(296, 5, 44, 17, "Map", ExitRoomEdit);
    Windows[RWin("Room Editor")]->AddListScrollBox(110, 5, 164, false, &selectedroom, 0);
    Windows[RWin("Room Editor")]->AddViewport(6, 25, 20, 18, 16);
    Windows[RWin("Room Editor")]->Viewports[0]->ResizeIn(0, 0);
    Windows[RWin("Room Editor")]->Viewports[0]->PriProc(RoomPlace);
    Windows[RWin("Room Editor")]->Viewports[0]->SecProc(RoomErase);
    Windows[RWin("Room Editor")]->Viewports[0]->HovProc(RoomHover, false);
    Windows[RWin("Room Editor")]->Viewports[0]->DrawProc(RoomDraw);
    Windows[RWin("Room Editor")]->Viewports[0]->OutProc(RoomViewport);
    Windows[RWin("Room Editor")]->ScrollBoxes[0]->SetFunction(EditRoom);
    Windows[RWin("Room Editor")]->AddSelector(54, 332, 24, 24, ToolSelect, &selectedtool, 0);
    Windows[RWin("Room Editor")]->AddSelector(88, 332, 24, 24, ToolEyedrop, &selectedtool, 1);
    Windows[RWin("Room Editor")]->AddSelector(122, 332, 24, 24, TileImages[0], &selectedtool, 2);
    Windows[RWin("Room Editor")]->AddButton(122, 359, 25, 4, "", OpenTileEdits);
    Windows[RWin("Room Editor")]->AddSelector(156, 332, 24, 24, ToolDoor, &selectedtool, 3);
    Windows[RWin("Room Editor")]->AddButton(156, 359, 25, 4, "", OpenDoors);
    Windows[RWin("Room Editor")]->AddSelector(190, 332, 24, 24, ItemImages[15], &selectedtool, 4);
    Windows[RWin("Room Editor")]->AddButton(190, 359, 25, 4, "", OpenItems);
    Windows[RWin("Room Editor")]->AddSelector(224, 332, 24, 24, ToolEnemy, &selectedtool, 5);
    
    NewWindow(8, 8, 268, 64, "Room Properties", CloseRoomProperties);
    /*Windows[RWin("Room Properties")]->AddLabel(8, 6, "Room Name:");
    Windows[RWin("Room Properties")]->AddTextBox(8, 20, 160, false, EditRoomName);
    Windows[RWin("Room Properties")]->AddButton(176, 20, 48, 17, "Set", EditRoomNameButton);*/
    Windows[RWin("Room Properties")]->AddLabel(8, 6, "Ambient Music:");
    Windows[RWin("Room Properties")]->AddListScrollBox(4, 20, 240, false, &selectedtune, 22,
	"No Music", 
    "Boss Battle 1",
    "Boss Battle 2",
    "Brinstar Green",
    "Brinstar Red",
    "Expectation",
    "Crateria Raining",
    "Crateria Surface",
    "Crateria Underground",
    "Item Room",
    "Maridia Natural",
    "Maridia Metal",
    "Mini-Boss",
    "Mother Brain Boss",
    "Norfair",
    "Norfair Depths",
    "Space Colony Self Destruct",
    "Space Colony Tranquil",
    "Statue Room",
    "Tourian Bubbling",
    "Tourian Tension",
    "Wrecked Ship");
    Windows[RWin("Room Properties")]->ScrollBoxes[0]->SetFunction(SetRoomMusic);
    /*Windows[RWin("Room Properties")]->AddLabel(8, 42, "Water");
    Windows[RWin("Room Properties")]->AddLabel(8, 44, "_____");
    Windows[RWin("Room Properties")]->AddLabel(8, 56, "High Tide:");
    Windows[RWin("Room Properties")]->AddTextBox(176, 52, 48, true, AppendRoom);*/
        
    NewWindow(main_width / 2 - 88, main_height / 2 - 40, 240, 80, "New Room", NULLF);
    Windows[RWin("New Room")]->Immobile();
    Windows[RWin("New Room")]->NoShade();
    Windows[RWin("New Room")]->NoClose();
    Windows[RWin("New Room")]->NoReturn();
    Windows[RWin("New Room")]->AddLabel(8, 6, "Enter the room name:");
    Windows[RWin("New Room")]->AddButton(176, 20, 56, 17, "Okay", AppendRoomButton);
    Windows[RWin("New Room")]->AddButton(176, 40, 56, 17, "Cancel", ExitDialog);
    Windows[RWin("New Room")]->AddTextBox(8, 20, 160, false, AppendRoom);
    Windows[RWin("New Room")]->AddCheckBox(8, 40, "Save Name", SaveRoomName);
    Windows[RWin("New Room")]->CheckBoxes[0]->State(true);
    
    NewWindow(main_width / 2 - 160, main_height / 2 - 44, 320, 88, "Import Room", NULLF);
    Windows[RWin("Import Room")]->Immobile();
    Windows[RWin("Import Room")]->NoShade();
    Windows[RWin("Import Room")]->NoClose();
    Windows[RWin("Import Room")]->NoReturn();
    Windows[RWin("Import Room")]->AddLabel(8, 4, "Directory: \\Levels\\*.lev");
    Windows[RWin("Import Room")]->AddLabel(8, 16, "Enter the file name:");
    Windows[RWin("Import Room")]->AddButton(256, 30, 56, 17, "Okay", ImportRoomButton);
    Windows[RWin("Import Room")]->AddButton(256, 50, 56, 17, "Cancel", ExitDialog);
    Windows[RWin("Import Room")]->AddTextBox(8, 30, 240, false, ImportRoom);
    Windows[RWin("Import Room")]->AddCheckBox(8, 50, "Save Name", SaveImportName);
    Windows[RWin("Import Room")]->CheckBoxes[0]->State(true);
    
    NewWindow(main_width / 2 - 160, main_height / 2 - 44, 320, 88, "Export Room", NULLF);
    Windows[RWin("Export Room")]->Immobile();
    Windows[RWin("Export Room")]->NoShade();
    Windows[RWin("Export Room")]->NoClose();
    Windows[RWin("Export Room")]->NoReturn();
    Windows[RWin("Export Room")]->AddLabel(8, 4, "Directory: \\Levels\\*.lev");
    Windows[RWin("Export Room")]->AddLabel(8, 16, "Enter the file name:");
    Windows[RWin("Export Room")]->AddButton(256, 30, 56, 17, "Okay", ExportRoomButton);
    Windows[RWin("Export Room")]->AddButton(256, 50, 56, 17, "Cancel", ExitDialog);
    Windows[RWin("Export Room")]->AddTextBox(8, 30, 240, false, ExportRoom);
    Windows[RWin("Export Room")]->AddCheckBox(8, 50, "Save Name", SaveExportName);
    Windows[RWin("Export Room")]->CheckBoxes[0]->State(true);
    
    NewWindow(main_width / 2 - 160, main_height / 2 - 44, 320, 88, "Save Room", NULLF);
    Windows[RWin("Save Room")]->Immobile();
    Windows[RWin("Save Room")]->NoShade();
    Windows[RWin("Save Room")]->NoClose();
    Windows[RWin("Save Room")]->NoReturn();
    Windows[RWin("Save Room")]->AddLabel(8, 4, "Directory: \\Levels\\*.sma");
    Windows[RWin("Save Room")]->AddLabel(8, 16, "Enter the file name:");
    Windows[RWin("Save Room")]->AddButton(256, 30, 56, 17, "Okay", SaveRoomButton);
    Windows[RWin("Save Room")]->AddButton(256, 50, 56, 17, "Cancel", ExitDialog);
    Windows[RWin("Save Room")]->AddTextBox(8, 30, 240, false, SaveRoom);
    Windows[RWin("Save Room")]->AddCheckBox(8, 50, "Save Name", SaveImportName);
    Windows[RWin("Save Room")]->CheckBoxes[0]->State(true);
    
    NewWindow(main_width / 2 - 160, main_height / 2 - 44, 320, 88, "Load Room", NULLF);
    Windows[RWin("Load Room")]->Immobile();
    Windows[RWin("Load Room")]->NoShade();
    Windows[RWin("Load Room")]->NoClose();
    Windows[RWin("Load Room")]->NoReturn();
    Windows[RWin("Load Room")]->AddLabel(8, 4, "Directory: \\Levels\\*.sma");
    Windows[RWin("Load Room")]->AddLabel(8, 16, "Enter the file name:");
    Windows[RWin("Load Room")]->AddButton(256, 30, 56, 17, "Okay", LoadRoomButton);
    Windows[RWin("Load Room")]->AddButton(256, 50, 56, 17, "Cancel", ExitDialog);
    Windows[RWin("Load Room")]->AddTextBox(8, 30, 240, false, LoadRoom);
    Windows[RWin("Load Room")]->AddCheckBox(8, 50, "Save Name", SaveImportName);
    Windows[RWin("Load Room")]->CheckBoxes[0]->State(true);
    
    NewWindow(main_width / 2 - 255, main_height / 2 - 250, 510, 458, "Place Imported Room", NULLF);
    Windows[RWin("Place Imported Room")]->Immobile();
    Windows[RWin("Place Imported Room")]->NoShade();
    Windows[RWin("Place Imported Room")]->NoClose();
    Windows[RWin("Place Imported Room")]->NoReturn();
    Windows[RWin("Place Imported Room")]->AddViewport(6, 5, 30, 26, 16);
    Windows[RWin("Place Imported Room")]->Viewports[0]->ResizeIn(MapXSize, MapYSize);
    Windows[RWin("Place Imported Room")]->Viewports[0]->PriRelProc(ImportPlace);
    Windows[RWin("Place Imported Room")]->Viewports[0]->HovProc(ImportHover, false);
    Windows[RWin("Place Imported Room")]->Viewports[0]->OutProc(MapViewport);
    Windows[RWin("Place Imported Room")]->Viewports[0]->DrawProc(ImportDraw);
    Windows[RWin("Place Imported Room")]->Viewports[0]->Grid(0);
    
    //Windows[WinMapEdit]->AddScrollBox(316, 204, 48, true, &selectedroom, 0, roomamount, 1);
    //Windows[WinMapEdit]->AddScrollBox(316, 92, 48, true, &senna, 0, 100, 1);
    //Windows[WinMapEdit]->AddScrollBox(316, 102, 48, true, &senna, 0, 100, 1);
    /*
    NewWindow(8, 344, 460, 80, "Tiles", CloseTiles);
    for(short i = 0; i < 16; i ++) {
        Windows[WinTiles]->AddSelector(4 + i * 28, 4, 24, 24, TileImages[i], &selectedtile, i + 1);
    }*/
    NewWindow(main_width - 255, main_height - 130, 254, 112, "Options", CloseOpts);
    Windows[RWin("Options")]->AddLabel(10, 8, "Music Volume:");
    Windows[RWin("Options")]->AddSlider(7, 24, 234, &senna, 0, 100, 1, true);
    Windows[RWin("Options")]->AddScrollBox(186, 5, 40, false, &senna, 0, 100, 1);
    Windows[RWin("Options")]->AddLabel(4, 40, "Screen Resolution:");
    Windows[RWin("Options")]->AddListScrollBox(4, 52, 80, false, &main_size, 5, "640x480", "800x600", "848x480", "960x600" , "1024x768");
    Windows[RWin("Options")]->AddButton(208, 52, 36, 17, "Set", Set_Screen);
    Windows[RWin("Options")]->AddCheckBox(104, 54, "Fullscreen", &fullscreen);
    
    NewWindow(main_width / 2 - 152, main_height / 2 - 32, 304, 64, "Import Error", NULLF);
    Windows[RWin("Import Error")]->Immobile();
    Windows[RWin("Import Error")]->NoShade();
    Windows[RWin("Import Error")]->NoClose();
    Windows[RWin("Import Error")]->NoReturn();
    Windows[RWin("Import Error")]->AddLabel(6, 6, "There was an error loading the room.");
    Windows[RWin("Import Error")]->AddButton(124, 24, 56, 17, "Okay", ExitDialog);
    
    NewWindow(main_width / 2 - 152, main_height / 2 - 32, 304, 64, "Cannot Import", NULLF);
    Windows[RWin("Cannot Import")]->Immobile();
    Windows[RWin("Cannot Import")]->NoShade();
    Windows[RWin("Cannot Import")]->NoClose();
    Windows[RWin("Cannot Import")]->NoReturn();
    Windows[RWin("Cannot Import")]->AddLabel(6, 6, "A room with this name alrady exists.");
    Windows[RWin("Cannot Import")]->AddButton(124, 24, 56, 17, "Okay", ExitDialog);
    
    NewWindow(main_width / 2 - 152, main_height / 2 - 36, 304, 72, "Invalid Level", NULLF);
    Windows[RWin("Invalid Level")]->Immobile();
    Windows[RWin("Invalid Level")]->NoShade();
    Windows[RWin("Invalid Level")]->NoClose();
    Windows[RWin("Invalid Level")]->NoReturn();
    Windows[RWin("Invalid Level")]->AddLabel(6, 6, "This level format is obsolete,");
    Windows[RWin("Invalid Level")]->AddLabel(6, 16, "please update before continuing.");
    Windows[RWin("Invalid Level")]->AddButton(124, 32, 56, 17, "Okay", ExitDialog);
    
    NewWindow(main_width / 2 - 152, main_height / 2 - 32, 304, 64, "Export Error", NULLF);
    Windows[RWin("Export Error")]->Immobile();
    Windows[RWin("Export Error")]->NoShade();
    Windows[RWin("Export Error")]->NoClose();
    Windows[RWin("Export Error")]->NoReturn();
    Windows[RWin("Export Error")]->AddLabel(6, 6, "The file could not be created.");
    Windows[RWin("Export Error")]->AddButton(124, 24, 56, 17, "Okay", ExitDialog);
    
    //NewWindow(376, 16, 144, 252, "Tiles", CloseTiles);
    /*for(short y = 0; y < 4; y ++) {
        for(short x = 0; x < 4; x ++) {
            Windows[WinTiles]->AddSelector(8 + x * 32, 8 + y * 32, 24, 24, TileImages[y* 4 + x], &selectedtile, y * 4 + x + 1);
        }
    }/*
    NewWindow(532, 16, 88, 316, "Clips", NULLF);
    OpenWindow(WinClips);
    NewWindow(376, 276, 144, 56, "Block Type", NULLF);
    OpenWindow(WinBlock);
    NewWindow(26, 12, 308, 308, "ViewPort", CloseViewport);
    OpenWindow(WinViewport);
    NewWindow(12, 336, 328, 56, "Level", NULLF);
    OpenWindow(WinLevel);
    NewWindow(12, 400, 328, 56, "Music Player", NULLF);
    OpenWindow(WinMusic);*/
    
    OpenWindow(RWin("Map Editor"));
    //OpenWindow(RWin("Tiles"));
}
