
#include "commonheaders.h"
#include "cls-menu.h"
#include "cls-window.h"
#include "initialization.h"
#include "menufunctions.h"
#include "winfunctions.h"
#include "processing.h"
#include "window.h"

short senna;
short boo;
short rot;
bool zarg;
char *texty;
char ** DogList;
short dogs = 0;

void Initialize_Windows(void) {
    MapXSize = 36;
    MapYSize = 28;
    MapGrid = (unsigned short **)malloc(sizeof(unsigned short *) * (MapYSize));
    for(short i = 0; i < MapYSize; i++) {
        MapGrid[i] = (unsigned short *)malloc(sizeof(unsigned short) * (MapXSize));
        for(short j = 0; j < MapXSize; j++) {
            MapGrid[i][j] = 0;
        }
    }
    MapSpec = (unsigned short **)malloc(sizeof(unsigned short *) * (MapYSize));
    for(short i = 0; i < MapYSize; i++) {
        MapSpec[i] = (unsigned short *)malloc(sizeof(unsigned short) * (MapXSize));
        for(short j = 0; j < MapXSize; j++) {
            MapSpec[i][j] = 0;
        }
    }
    selectedroom = 0;
    roomamount = 0;

    clear_keybuf();

    NewWindow(8, 8, 488, 264, "Map Editor", CloseMapEdit);
    //Windows[WinMapEdit]->AddSelector(4, 4, 300, 300, "Viewport", &boo, 1);
    Windows[RWin("Map Editor")]->AddViewport(6, 5, 18, 14, 16);
    Windows[RWin("Map Editor")]->Viewports[0]->ResizeIn(MapXSize, MapYSize);
    Windows[RWin("Map Editor")]->Viewports[0]->PriProc(MapPlace);
    Windows[RWin("Map Editor")]->Viewports[0]->SecProc(MapErase);
    Windows[RWin("Map Editor")]->Viewports[0]->HovProc(MapHover, false);
    Windows[RWin("Map Editor")]->Viewports[0]->DrawProc(MapDraw);
    Windows[RWin("Map Editor")]->Viewports[0]->OutProc(MapViewport);
    Windows[RWin("Map Editor")]->Viewports[0]->Grid(0);
    Windows[RWin("Map Editor")]->AddButton(314, 4, 80, 21, "New Room", OpenRoomDialog);
    Windows[RWin("Map Editor")]->AddButton(398, 4, 24, 21, Delete, DeleteRoom);
    Windows[RWin("Map Editor")]->AddButton(426, 4, 24, 21, "UP", UpRoom);
    Windows[RWin("Map Editor")]->AddButton(454, 4, 24, 21, "DN", DnRoom);
    Windows[RWin("Map Editor")]->AddSelector(314, 116, 20, 20, MapBox, &roomtype, 0);
    Windows[RWin("Map Editor")]->AddSelector(338, 116, 20, 20, MapItem, &roomtype, 1);
    Windows[RWin("Map Editor")]->AddSelector(362, 116, 20, 20, MapSlice1, &roomtype, 2);
    Windows[RWin("Map Editor")]->AddSelector(386, 116, 20, 20, MapSlice2, &roomtype, 3);
    Windows[RWin("Map Editor")]->AddSelector(410, 116, 20, 20, MapSlice3, &roomtype, 4);
    Windows[RWin("Map Editor")]->AddSelector(434, 116, 20, 20, MapSlice4, &roomtype, 5);
    Windows[RWin("Map Editor")]->AddSelector(458, 116, 20, 20, MapElevator, &roomtype, 6);
    Windows[RWin("Map Editor")]->AddSelector(314, 140, 40, 30, MapBStretch, &roomtype, 7);
    Windows[RWin("Map Editor")]->AddSelector(358, 140, 40, 30, MapDStretch, &roomtype, 9);
    Windows[RWin("Map Editor")]->AddSelector(402, 140, 75, 30, "Label", &roomtype, 8);
    Windows[RWin("Map Editor")]->AddLabel(314, 174, "Properties:");
    Windows[RWin("Map Editor")]->AddButton(314, 184, 80, 21, "Edit Room", EditRoom);
    Windows[RWin("Map Editor")]->AddButton(398, 184, 80, 21, "Room Info", NULLF);
    Windows[RWin("Map Editor")]->AddLabel(314, 210, "Clear Room Map:");
    Windows[RWin("Map Editor")]->AddButton(314, 220, 80, 21, "Room", ClearRoom);
    Windows[RWin("Map Editor")]->AddButton(398, 220, 80, 21, "All", ClearAll);
    Windows[RWin("Map Editor")]->Selectors[8]->Disable();
    Windows[RWin("Map Editor")]->Selectors[9]->Disable();
    Windows[RWin("Map Editor")]->AddListBox(314, 28, 164, 8, &selectedroom, 0);

    NewWindow(376, 8, 144, 256, "Tiles", CloseTiles);
    for(short y = 0; y < 4; y ++) {
        for(short x = 0; x < 4; x ++) {
            Windows[RWin("Tiles")]->AddSelector(8 + x * 32, 7 + y * 32, 24, 24, TileImages[y* 4 + x], &selectedtile, y * 4 + x + 1);
            Windows[RWin("Tiles")]->Selectors[y* 4 + x]->SetFunction(RefreshTilePreview);
        }
    }
    Windows[RWin("Tiles")]->AddLabel(12, 136, "Tile:");
    Windows[RWin("Tiles")]->AddScrollBox(56, 132, 56, false, &selectedtile, 1, tileamount, 1);
    Windows[RWin("Tiles")]->AddLabel(12, 156, "Row:");
    Windows[RWin("Tiles")]->AddScrollBox(56, 152, 56, false, &tilerow, 1, tileamount / 16, 1);
    Windows[RWin("Tiles")]->AddListScrollBox(8, 172, 66, false, &selectedflip, 4, "No Flip", "H Flip", "V Flip", "HV Flip");
    Windows[RWin("Tiles")]->AddScrollBox(8, 190, 66, false, &selectedrot, 0, 270, 90);
    Windows[RWin("Tiles")]->AddSelector(95, 172, 33, 33, "", &rot, -1);
    Windows[RWin("Tiles")]->AddCheckBox(8, 208, "Foreground", &foreground);
    Windows[RWin("Tiles")]->AddCheckBox(8, 222, "Transitional", &transitional);
    Windows[RWin("Tiles")]->Selectors[16]->NoSelect();
    /*Windows[RWin("Tiles")]->AddLabel(8, 36, "Tile:");
    Windows[RWin("Tiles")]->AddScrollBox(52, 32, 40, false, &selectedtile, 1, tileamount, 1);
    Windows[RWin("Tiles")]->AddLabel(116, 36, "Row:");
    Windows[RWin("Tiles")]->AddScrollBox(152, 32, 40, false, &tilerow, 1, tileamount / 16, 1);*/
    Windows[RWin("Tiles")]->ScrollBoxes[0]->SetFunction(ProcessTiles);
    Windows[RWin("Tiles")]->ScrollBoxes[1]->SetFunction(ProcessRows);
    Windows[RWin("Tiles")]->ScrollBoxes[2]->SetFunction(RefreshTilePreview);
    Windows[RWin("Tiles")]->ScrollBoxes[3]->SetFunction(RefreshTilePreview);
    RefreshTilePreview();
    
    NewWindow(536, 8, 88, 332, "Clips", NULLF);
    for(short y = 0; y < 8; y ++) {
        for(short x = 0; x < 2; x ++) {
            Windows[RWin("Clips")]->AddSelector(10 + x * 36, 7 + y * 32, 24, 24, ClipImages[y* 2 + x], &selectedclip, y * 2 + x + 1);
        }
    }
    Windows[RWin("Clips")]->AddScrollBox(10, 264, 46, false, &selectedclip, 1, clipamount, 1);
    Windows[RWin("Clips")]->AddLabel(12, 283, "Page:");
    Windows[RWin("Clips")]->AddScrollBox(10, 292, 46, false, &clippage, 1, (clipamount / 16) + (clipamount % 16 > 0 ? 1 : 0), 1);
    Windows[RWin("Clips")]->ScrollBoxes[0]->SetFunction(ProcessClips);
    Windows[RWin("Clips")]->ScrollBoxes[1]->SetFunction(ProcessClipRows);
    
    //NewWindow(8, 8, 350, 320, "Room Properties", CloseRoomProp);
    
    NewWindow(8, 8, 350, 350, "Room Editor", CloseRoomEdit);
    Windows[RWin("Room Editor")]->AddLabel(6, 9, "Editing Room:");
    Windows[RWin("Room Editor")]->AddLabel(6, 308, "Tool:");
    //Windows[RWin("Room Editor")]->AddLabel(6, 308, "Tools:");
    Windows[RWin("Room Editor")]->AddButton(296, 5, 44, 17, "Map", ExitRoomEdit);
    Windows[RWin("Room Editor")]->AddListScrollBox(110, 5, 164, false, &selectedroom, 0);
    Windows[RWin("Room Editor")]->AddViewport(6, 25, 20, 16, 16);
    Windows[RWin("Room Editor")]->Viewports[0]->ResizeIn(0, 0);
    Windows[RWin("Room Editor")]->Viewports[0]->PriProc(RoomPlace);
    Windows[RWin("Room Editor")]->Viewports[0]->SecProc(RoomErase);
    Windows[RWin("Room Editor")]->Viewports[0]->HovProc(RoomHover, false);
    Windows[RWin("Room Editor")]->Viewports[0]->DrawProc(RoomDraw);
    Windows[RWin("Room Editor")]->Viewports[0]->OutProc(RoomViewport);
    Windows[RWin("Room Editor")]->ScrollBoxes[0]->SetFunction(EditRoom);
    Windows[RWin("Room Editor")]->AddSelector(54, 300, 24, 24, "[]", &boo, 0);
    Windows[RWin("Room Editor")]->AddSelector(88, 300, 24, 24, "<>", &boo, 1);
    Windows[RWin("Room Editor")]->AddSelector(122, 300, 24, 24, TileImages[0], &boo, 2);
    Windows[RWin("Room Editor")]->AddSelector(156, 300, 24, 24, "()", &boo, 3);
    Windows[RWin("Room Editor")]->AddSelector(190, 300, 24, 24, "||", &boo, 4);
    Windows[RWin("Room Editor")]->AddSelector(224, 300, 24, 24, "\\/", &boo, 5);
        
    NewWindow(main_width / 2 - 88, main_height / 2 - 40, 240, 80, "New Room", NULLF);
    Windows[RWin("New Room")]->Immobile();
    Windows[RWin("New Room")]->NoShade();
    Windows[RWin("New Room")]->NoClose();
    Windows[RWin("New Room")]->NoReturn();
    Windows[RWin("New Room")]->AddLabel(8, 6, "Enter the room name:");
    Windows[RWin("New Room")]->AddButton(176, 20, 56, 17, "Okay", AppendRoomButton);
    Windows[RWin("New Room")]->AddButton(176, 40, 56, 17, "Cancel", ExitDialog);
    Windows[RWin("New Room")]->AddTextBox(8, 20, 160, true, AppendRoom);
    Windows[RWin("New Room")]->AddCheckBox(8, 40, "Save Name", SaveRoomName);
    
    NewWindow(main_width / 2 - 160, main_height / 2 - 90, 320, 180, "Import Room", NULLF);
    Windows[RWin("Import Room")]->Immobile();
    Windows[RWin("Import Room")]->NoShade();
    Windows[RWin("Import Room")]->NoClose();
    Windows[RWin("Import Room")]->NoReturn();
    Windows[RWin("Import Room")]->AddLabel(8, 4, "Directory: \\Levels\\*.lev");
    Windows[RWin("Import Room")]->AddLabel(8, 16, "Enter the file name:");
    Windows[RWin("Import Room")]->AddButton(256, 30, 56, 17, "Okay", ImportRoomButton);
    Windows[RWin("Import Room")]->AddButton(256, 50, 56, 17, "Cancel", ExitDialog);
    Windows[RWin("Import Room")]->AddTextBox(8, 30, 240, true, ImportRoom);
    Windows[RWin("Import Room")]->AddCheckBox(8, 50, "Save Name", SaveImportName);
    Windows[RWin("Import Room")]->AddSelector(2, 70, 310, 87, "", &rot, -1);
    Windows[RWin("Import Room")]->Selectors[0]->NoSelect();
    Windows[RWin("Import Room")]->AddLabel(8, 74, "*** WARNING ***");
    Windows[RWin("Import Room")]->AddLabel(8, 76, "_______________");
    Windows[RWin("Import Room")]->AddLabel(5, 90, "Features not supported in this version");
    Windows[RWin("Import Room")]->AddLabel(5, 100, "will not be loaded (Enemies, Items,");
    Windows[RWin("Import Room")]->AddLabel(5, 110, "Camera Boundries, Doors, Water, etc).");
    Windows[RWin("Import Room")]->AddLabel(5, 125, "Default values will be written to");
    Windows[RWin("Import Room")]->AddLabel(5, 135, "exported levels. Please backup your");
    Windows[RWin("Import Room")]->AddLabel(5, 135, "                        ______");
    Windows[RWin("Import Room")]->AddLabel(5, 145, "existing copies for future releases.");
    
    NewWindow(main_width / 2 - 160, main_height / 2 - 90, 320, 180, "Export Room", NULLF);
    Windows[RWin("Export Room")]->Immobile();
    Windows[RWin("Export Room")]->NoShade();
    Windows[RWin("Export Room")]->NoClose();
    Windows[RWin("Export Room")]->NoReturn();
    Windows[RWin("Export Room")]->AddLabel(8, 4, "Directory: \\Levels\\*.lev");
    Windows[RWin("Export Room")]->AddLabel(8, 16, "Enter the file name:");
    Windows[RWin("Export Room")]->AddButton(256, 30, 56, 17, "Okay", ExportRoomButton);
    Windows[RWin("Export Room")]->AddButton(256, 50, 56, 17, "Cancel", ExitDialog);
    Windows[RWin("Export Room")]->AddTextBox(8, 30, 240, true, ExportRoom);
    Windows[RWin("Export Room")]->AddCheckBox(8, 50, "Save Name", SaveExportName);
    Windows[RWin("Export Room")]->AddSelector(2, 70, 310, 87, "", &rot, -1);
    Windows[RWin("Export Room")]->Selectors[0]->NoSelect();
    Windows[RWin("Export Room")]->AddLabel(8, 74, "*** WARNING ***");
    Windows[RWin("Export Room")]->AddLabel(8, 76, "_______________");
    Windows[RWin("Export Room")]->AddLabel(5, 90, "Features not supported in this version");
    Windows[RWin("Export Room")]->AddLabel(5, 100, "will not be saved (Enemies, Items,");
    Windows[RWin("Export Room")]->AddLabel(5, 110, "Camera Boundries, Doors, Water, etc).");
    Windows[RWin("Export Room")]->AddLabel(5, 125, "Default values will be written to");
    Windows[RWin("Export Room")]->AddLabel(5, 135, "exported levels. Please backup your");
    Windows[RWin("Export Room")]->AddLabel(5, 135, "                        ______");
    Windows[RWin("Export Room")]->AddLabel(5, 145, "existing copies for future releases.");
    
    NewWindow(main_width / 2 - 159, main_height / 2 - 133, 318, 266, "Place Imported Room", NULLF);
    Windows[RWin("Place Imported Room")]->Immobile();
    Windows[RWin("Place Imported Room")]->NoShade();
    Windows[RWin("Place Imported Room")]->NoClose();
    Windows[RWin("Place Imported Room")]->NoReturn();
    Windows[RWin("Place Imported Room")]->AddViewport(6, 5, 18, 14, 16);
    Windows[RWin("Place Imported Room")]->Viewports[0]->ResizeIn(MapXSize, MapYSize);
    Windows[RWin("Place Imported Room")]->Viewports[0]->PriRelProc(ImportPlace);
    Windows[RWin("Place Imported Room")]->Viewports[0]->HovProc(ImportHover, false);
    Windows[RWin("Place Imported Room")]->Viewports[0]->OutProc(MapViewport);
    Windows[RWin("Place Imported Room")]->Viewports[0]->DrawProc(ImportDraw);
    Windows[RWin("Place Imported Room")]->Viewports[0]->Grid(0);
    
    //Windows[WinMapEdit]->AddScrollBox(316, 204, 48, true, &selectedroom, 0, roomamount, 1);
    //Windows[WinMapEdit]->AddScrollBox(316, 92, 48, true, &senna, 0, 100, 1);
    //Windows[WinMapEdit]->AddScrollBox(316, 102, 48, true, &senna, 0, 100, 1);
    /*
    NewWindow(8, 344, 460, 80, "Tiles", CloseTiles);
    for(short i = 0; i < 16; i ++) {
        Windows[WinTiles]->AddSelector(4 + i * 28, 4, 24, 24, TileImages[i], &selectedtile, i + 1);
    }*/
    NewWindow(main_width - 255, main_height - 130, 254, 112, "Options", CloseOpts);
    Windows[RWin("Options")]->AddLabel(10, 8, "Music Volume:");
    Windows[RWin("Options")]->AddSlider(7, 24, 234, &senna, 0, 100, 1, true);
    Windows[RWin("Options")]->AddScrollBox(186, 5, 40, false, &senna, 0, 100, 1);
    Windows[RWin("Options")]->AddLabel(4, 40, "Screen Resolution:");
    Windows[RWin("Options")]->AddListScrollBox(4, 52, 80, false, &main_size, 7, "512x384", "640x400", "640x480", "800x600", "848x480", "960x600" , "1024x768");
    Windows[RWin("Options")]->AddButton(208, 52, 36, 17, "Set", Set_Screen);
    Windows[RWin("Options")]->AddCheckBox(104, 54, "Fullscreen", &fullscreen);
    
    NewWindow(main_width / 2 - 152, main_height / 2 - 32, 304, 64, "Import Error", NULLF);
    Windows[RWin("Import Error")]->Immobile();
    Windows[RWin("Import Error")]->NoShade();
    Windows[RWin("Import Error")]->NoClose();
    Windows[RWin("Import Error")]->NoReturn();
    Windows[RWin("Import Error")]->AddLabel(6, 6, "There was an error loading the room.");
    Windows[RWin("Import Error")]->AddButton(124, 24, 56, 17, "Okay", ExitDialog);
    
    NewWindow(main_width / 2 - 152, main_height / 2 - 32, 304, 64, "Export Error", NULLF);
    Windows[RWin("Export Error")]->Immobile();
    Windows[RWin("Export Error")]->NoShade();
    Windows[RWin("Export Error")]->NoClose();
    Windows[RWin("Export Error")]->NoReturn();
    Windows[RWin("Export Error")]->AddLabel(6, 6, "The file could not be created.");
    Windows[RWin("Export Error")]->AddButton(124, 24, 56, 17, "Okay", ExitDialog);
    //NewWindow(376, 16, 144, 252, "Tiles", CloseTiles);
    /*for(short y = 0; y < 4; y ++) {
        for(short x = 0; x < 4; x ++) {
            Windows[WinTiles]->AddSelector(8 + x * 32, 8 + y * 32, 24, 24, TileImages[y* 4 + x], &selectedtile, y * 4 + x + 1);
        }
    }/*
    NewWindow(532, 16, 88, 316, "Clips", NULLF);
    OpenWindow(WinClips);
    NewWindow(376, 276, 144, 56, "Block Type", NULLF);
    OpenWindow(WinBlock);
    NewWindow(26, 12, 308, 308, "ViewPort", CloseViewport);
    OpenWindow(WinViewport);
    NewWindow(12, 336, 328, 56, "Level", NULLF);
    OpenWindow(WinLevel);
    NewWindow(12, 400, 328, 56, "Music Player", NULLF);
    OpenWindow(WinMusic);*/
    
    OpenWindow(RWin("Options"));
    OpenWindow(RWin("Map Editor"));
    OpenWindow(RWin("Clips"));
    //OpenWindow(RWin("Room Editor"));
    //OpenWindow(RWin("Tiles"));
}
